<?php
namespace dsmirror;
require_once 'IRESTClient.php';

/**
 *
 * @author Tecknolab
 *        
 */
abstract class RESTClient implements IRESTClient
{
    protected $endpoint;
    protected $appId;
    protected $secret;
    protected $commonHeaders=Array();
    
    /**
     */
    public function __construct($endpoint, $appId, $secret, $appVersion, $provider)
    {
        $this->endpoint = $endpoint;
        $this->appId = $appId;
        $this->secret = $secret;
        $this->commonHeaders=array('x-dsmirror-version' => $appVersion, 'x-dsmirror-provider'=>$provider);
    }
        
    protected function getAuthToken()
    {
        $nonce = $this->generateRandomString();
        $ts = floor(microtime(true) * 1000);
        $authtoken = $nonce . "," . $ts . "," . hash_hmac('sha256',$this->appId . $nonce . $ts, $this->secret);
        return $authtoken;
    }

    protected function generateRandomString($length = 8) {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
}

class RESTException extends \Exception
{
    // Redefine the exception so message isn't optional
    public function __construct($message, $httpCode = 0, Throwable $previous = null) {
        // make sure everything is assigned properly
        parent::__construct($message, $httpCode, $previous);
    }
}